/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
#include "Behavioural/include/XML.h"
using namespace std;

namespace morpheo                    {
namespace behavioural {
namespace generic {
namespace registerfile {


  string Parameters::print (uint32_t depth)
  {
    log_printf(FUNC,RegisterFile,"print","Begin");

    string _return;

    if (_instance == instance_RegisterFile_Monolithic)
      _return = _param_registerfile_monolithic  ->print(depth);
    else
      _return = _param_registerfile_multi_banked->print(depth);

    log_printf(FUNC,RegisterFile,"print","End");
    
    return _return;
  };

  ostream& operator<< (ostream& output_stream ,
		       morpheo::behavioural::generic::registerfile::Parameters & x)
  {
    if (x._instance == instance_RegisterFile_Monolithic)
      output_stream << x._param_registerfile_monolithic  ->print(0);
    else
      output_stream << x._param_registerfile_multi_banked->print(0);
    
    return output_stream;
  };

}; // end namespace registerfile
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
